//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <strmif.h>
#include <control.h>
#include <uuids.h>
#include <evcode.h>
#include "spi_api.h"
#include "ifmmvar.h"
#include "mixerctr.h"

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#define WM_GRAPHNOTIFY	WM_USER+500
class TPlayForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
        TPanel *MovieP;
        TPanel *Panel;
        TScrollBox *ScrollBox;
        TStatusBar *StatusBar;
        TTrackBar *TrackBar;
        TPopupMenu *PopupMenu;
        TMenuItem *sec10;
        TMenuItem *min1;
        TMenuItem *min5;
        TMenuItem *min10;
        TMenuItem *sec30;
        TMenuItem *sec1;
        TSpeedButton *PlaySB;
        TSpeedButton *PauseSB;
        TSpeedButton *PreSB;
        TMenuItem *Scale;
        TMenuItem *x1;
        TMenuItem *x2;
        TMenuItem *x4;
        TMenuItem *m1;
        TMenuItem *xC;
        TMenuItem *xF;
        TTrackBar *VolTB;
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);
    void __fastcall TrackBarChange(TObject *Sender);
    void __fastcall sec10Click(TObject *Sender);
    void __fastcall PlaySBClick(TObject *Sender);
        void __fastcall x1Click(TObject *Sender);
        void __fastcall ScrollBoxClick(TObject *Sender);
        void __fastcall VolTBChange(TObject *Sender);
private:	// [U[錾
    void __fastcall WMGraphNotify(TMessage &Msg);
    void __fastcall MM_MixCtrChange(TMessage &Msg);
    void __fastcall GetCustomRect(RECT *prc, int cwidth, int cheight);
    void __fastcall SetMovieRect(RECT *prc);
    void __fastcall ChangeRate(void);
    void __fastcall StatesTextUpdate(void);
    void __fastcall ChangeVolume(int vol);
    inline void __fastcall MuteToggle(void);
    void __fastcall putFullScreen(void);
public:		// [U[錾
    __fastcall TPlayForm(TComponent* Owner);
    void __fastcall FormResizeEx(TObject *Sender);
    void __fastcall FormResizeMovie(TObject *Sender);
    void __fastcall Play(void);
    void __fastcall FormMouseMoveEx(TObject *Sender,
      TShiftState Shift, int X, int Y);

    //DirectShow֌W
#define HELPER_RELEASE(x) { if ((x)) {(x)->Release(); (x) = NULL;} }
    IGraphBuilder *pgb;
    IMediaControl *pmc;
    IMediaEventEx *pmex;
    IVideoWindow *pvw;
    IMediaPosition *pmp;
//#define USE_IBA
#ifdef USE_IBA //
    IBasicAudio *pba;
#else //g
    MixerCtr volume;
#endif
    WCHAR wFile[MAX_PATH];

    IFMMVAR_STRUCT ifmmvar;
    long MWidth;  //̎ۂ̕
    long MHeight; //̎ۂ̍
    bool __fastcall MediaInit(void);
    bool __fastcall MediaOpen(void);
    void __fastcall MediaClose(void);
    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_GRAPHNOTIFY, TMessage, WMGraphNotify)
        MESSAGE_HANDLER(MM_MIXM_CONTROL_CHANGE, TMessage, MM_MixCtrChange)
        //MESSAGE_HANDLER(MM_MIXM_LINE_CHANGE, TMessage, MM_MixCtrChange)
    END_MESSAGE_MAP(TForm);

    //SusiẽR[obN֐
    SPI_PROGRESS lpPrgressCallback;
    long lData;

    void __fastcall MediaClick(int Button);
#define ST_READY -1
#define ST_PLAY  0
#define ST_STOP  1
#define ST_PAUSE 2
#define ST_ABORT 3
    int State; //v[[(fBA)̏
#define BTN_PLAY  0
#define BTN_PAUSE 1
#define BTN_PREV  2
    bool ch_auto;
    bool ch_manu;
    bool vol_ch;
    int TheLength; //fBA̒
    double MRate;  //sb`
    AnsiString length;
#define PER_01SEC " 1sec"
#define PER_10SEC "10sec"
#define PER_30SEC "30sec"
#define PER_01MIN " 1min"
#define PER_05MIN " 5min"
#define PER_10MIN "10min"
    AnsiString per;
//
#define TIME_01SEC     1*1000
#define TIME_10SEC    10*1000
#define TIME_30SEC    30*1000
#define TIME_01MIN    60*1000
#define TIME_05MIN  5*60*1000
#define TIME_10MIN 10*60*1000
};

//---------------------------------------------------------------------------
#endif
